; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.0.9
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - MatrixEncodedGenerator.pb
; Version du fichier : 0.9.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-08-2016
; Mise  jour : 24-05-2018
; Cod pour PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule MatrixEncodedGenerator
  
  Declare Initialize()
  Declare Reset()
  Declare Requester(MainWinID.i)
  Declare MatrixFinder()
  Declare Runner(MainWinID.i)
  Declare.s GenerateSource()
  
EndDeclareModule

Module MatrixEncodedGenerator
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #LineFeed = #CRLF$    
      #TwinLineFeed = #CRLF$ + #CRLF$
      
    CompilerCase #PB_OS_Linux
      #LineFeed = #LF$
      #TwinLineFeed = #LF$ + #LF$
      
    CompilerCase #PB_OS_MacOS
      #LineFeed = #CR$
      #TwinLineFeed = #CR$ + #CR$
      
  CompilerEndSelect
  
  #MATRIX_COUNT_MIN = 16
  #MATRIX_COUNT_MAX = 256
  #MATRIX_COUNT_MOY = 128
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration des Structures <<<<<
  
  Structure Secondary
    
    ProgressBarMatrix33.q
    ProgressBarMatrix44.q
    ProgressBarMatrix55.q
    
  EndStructure
  
  Structure Instance
    
    StartCounter.b
    Max.l
    MaxMatrix33.l
    MaxMatrix44.l
    MaxMatrix55.l
    AbandonState.b
    AbandonStateMatrix33.b
    AbandonStateMatrix44.b
    AbandonStateMatrix55.b
    CounterMatrix33.l
    CounterMatrix44.l
    CounterMatrix55.l
    MutexMatrix55.i
    List Matrix33.Matrix33::Matrix33()
    List Matrix44.Matrix44::Matrix44()
    List Matrix55.Matrix55::Matrix55()
    List Inverse33.Matrix33::Matrix33()
    List Inverse44.Matrix44::Matrix44()
    List Inverse55.Matrix55::Matrix55()
    
  EndStructure

  Global Secondary.Secondary
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetMax(P_Max.l)

    Instance\Max = P_Max
    Instance\MaxMatrix33 = P_Max
    Instance\MaxMatrix44 = P_Max
    Instance\MaxMatrix55 = P_Max

  EndProcedure

  Procedure SetAbandonState(P_AbandonState.b)

    Instance\AbandonState = P_AbandonState
    Instance\AbandonStateMatrix33 = P_AbandonState
    Instance\AbandonStateMatrix44 = P_AbandonState
    Instance\AbandonStateMatrix55 = P_AbandonState

  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Initialize <<<<<

  Procedure Initialize()
    
    InitializeStructure(Instance, Instance)
    
    SetMax(#MATRIX_COUNT_MOY)
    SetAbandonState(#False)

    Secondary\ProgressBarMatrix33 = 0
    Secondary\ProgressBarMatrix44 = 0
    Secondary\ProgressBarMatrix55 = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\StartCounter = 0
    Instance\Max = 0
    Instance\MaxMatrix33 = 0
    Instance\MaxMatrix44 = 0
    Instance\MaxMatrix55 = 0
    Instance\AbandonState = 0
    Instance\AbandonStateMatrix33 = 0
    Instance\AbandonStateMatrix44 = 0
    Instance\AbandonStateMatrix55 = 0
    Instance\CounterMatrix33 = 0
    Instance\CounterMatrix44 = 0
    Instance\CounterMatrix55 = 0

    ForEach Instance\Matrix33()
      Matrix33::Reset(Instance\Matrix33())
    Next

    FreeList(Instance\Matrix33())
    
    ForEach Instance\Matrix44()
      Matrix44::Reset(Instance\Matrix44())
    Next

    FreeList(Instance\Matrix44())
    
    ForEach Instance\Matrix55()
      Matrix55::Reset(Instance\Matrix55())
    Next

    FreeList(Instance\Matrix55())
    
    ForEach Instance\Inverse33()
      Matrix33::Reset(Instance\Inverse33())
    Next

    FreeList(Instance\Inverse33())
    
    ForEach Instance\Inverse44()
      Matrix44::Reset(Instance\Inverse44())
    Next

    FreeList(Instance\Inverse44())
    
    ForEach Instance\Inverse55()
      Matrix55::Reset(Instance\Inverse55())
    Next

    FreeList(Instance\Inverse55())
    
    Secondary\ProgressBarMatrix33 = 0
    Secondary\ProgressBarMatrix44 = 0
    Secondary\ProgressBarMatrix55 = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Nom de la procdure <<<<<
  
  Procedure Matrix33Finder(*Dummy)
    
    Vector3::Update(VecA.Vector3::Vector3, 50, 51, 45)
    
    Max = 18
    Dim Values(Max)
    
    For Index = 0 To Max
      Values(Index) = Index - (Max >> 1)
    Next
    
    Exit_Condition = #False
    
    While Exit_Condition = #False
      
      Matrix33::SetLine1(Matrix33A.Matrix33::Matrix33, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix33::SetLine2(Matrix33A.Matrix33::Matrix33, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix33::SetLine3(Matrix33A.Matrix33::Matrix33, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      
      If Matrix33::Inverse(Inverse33.Matrix33::Matrix33, Matrix33A)
        
        If Matrix33::IsIntegerMatrix(Inverse33)
          
          Matrix33::ProductMatrixVector(VecR.Vector3::Vector3, Matrix33A, VecA)
          Matrix33::ProductMatrixVector(VecB.Vector3::Vector3, Inverse33, VecR)
          
          If Vector3::Compare(VecA, VecB)
            
            AddElement(Instance\Matrix33())
            AddElement(Instance\Inverse33())
            Matrix33::Copy(Matrix33A, Instance\Matrix33())
            Matrix33::Copy(Inverse33, Instance\Inverse33())
            
            Instance\CounterMatrix33 + 1
            ProgressBarEx::Refresh(Secondary\ProgressBarMatrix33, Int((Instance\CounterMatrix33 / Instance\MaxMatrix33) * 100.0))
            
          EndIf
          
        EndIf
        
      EndIf

      If Instance\CounterMatrix33 = Instance\MaxMatrix33 Or Instance\AbandonStateMatrix33 = #True
        Exit_Condition = #True
      EndIf 
      
    Wend
    
    FreeArray(Values())
    
  EndProcedure
  
  Procedure Matrix44Finder(*Dummy)
    
    Vector4::Update(VecA.Vector4::Vector4, 50, 51, 45, 48)
    
    Max = 18
    Dim Values(Max)
    
    For Index = 0 To Max
      Values(Index) = Index - (Max >> 1)
    Next
    
    Exit_Condition = #False
    
    While Exit_Condition = #False
      
      Matrix44::SetLine1(Matrix44A.Matrix44::Matrix44, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix44::SetLine2(Matrix44A.Matrix44::Matrix44, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix44::SetLine3(Matrix44A.Matrix44::Matrix44, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix44::SetLine4(Matrix44A.Matrix44::Matrix44, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      
      If Matrix44::Inverse(Inverse44.Matrix44::Matrix44, Matrix44A)
        
        If Matrix44::IsIntegerMatrix(Inverse44)
          
          Matrix44::ProductMatrixVector(VecR.Vector4::Vector4, Matrix44A, VecA)
          Matrix44::ProductMatrixVector(VecB.Vector4::Vector4, Inverse44, VecR)
          
          If Vector4::Compare(VecA, VecB)
            
            AddElement(Instance\Matrix44())
            AddElement(Instance\Inverse44())
            Matrix44::Copy(Matrix44A, Instance\Matrix44())
            Matrix44::Copy(Inverse44, Instance\Inverse44())
            
            Instance\CounterMatrix44 + 1
            ProgressBarEx::Refresh(Secondary\ProgressBarMatrix44, Int((Instance\CounterMatrix44 / Instance\MaxMatrix44) * 100.0))
            
          EndIf
          
        EndIf
        
      EndIf
      
      If Instance\CounterMatrix44 = Instance\MaxMatrix44 Or Instance\AbandonStateMatrix44 = #True
        Exit_Condition = #True
      EndIf 

    Wend
    
    FreeArray(Values())
    
  EndProcedure
  
  Procedure Matrix55Finder(*Dummy)
    
    Vector5::Update(VecA.Vector5::Vector5, 50, 51, 45, 48, 56)
    
    Max = 18
    Dim Values(Max)
    
    For Index = 0 To Max
      Values(Index) = Index - (Max >> 1)
    Next
    
    Exit_Condition = #False
    
    While Exit_Condition = #False
      
      Matrix55::SetLine1(Matrix55A.Matrix55::Matrix55, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix55::SetLine2(Matrix55A.Matrix55::Matrix55, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix55::SetLine3(Matrix55A.Matrix55::Matrix55, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix55::SetLine4(Matrix55A.Matrix55::Matrix55, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      Matrix55::SetLine5(Matrix55A.Matrix55::Matrix55, Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)), Values(Random(Max)))
      
      If Matrix55::Inverse(Inverse55.Matrix55::Matrix55, Matrix55A)
        
        If Matrix55::IsIntegerMatrix(Inverse55)
          
          Matrix55::ProductMatrixVector(VecR.Vector5::Vector5, Matrix55A, VecA)
          Matrix55::ProductMatrixVector(VecB.Vector5::Vector5, Inverse55, VecR)
          
          If Vector5::Compare(VecA, VecB)
            
            LockMutex(Instance\MutexMatrix55)

            AddElement(Instance\Matrix55())
            AddElement(Instance\Inverse55())
            Matrix55::Copy(Matrix55A, Instance\Matrix55())
            Matrix55::Copy(Inverse55, Instance\Inverse55())
            
            Instance\CounterMatrix55 + 1
            
            If Instance\CounterMatrix55 >= Instance\MaxMatrix55
              Instance\CounterMatrix55 = Instance\MaxMatrix55
            EndIf
            
            ProgressBarEx::Refresh(Secondary\ProgressBarMatrix55, Int((Instance\CounterMatrix55 / Instance\MaxMatrix55) * 100.0))
            
            UnlockMutex(Instance\MutexMatrix55)
            
          EndIf
          
        EndIf
        
      EndIf
      
      If Instance\CounterMatrix55 >= Instance\MaxMatrix55 Or Instance\AbandonStateMatrix55 = #True
        Exit_Condition = #True
      EndIf 
      
    Wend
    
    FreeArray(Values())
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Nom de la procdure <<<<<
  
  Procedure Requester(MainWinID.i)
    
    RequesterHandle = OpenWindow(#PB_Any, 0, 0, 395, 135, Language::Message("Matrix Encoded Library Generator"), #PB_Window_WindowCentered, WindowID(MainWinID))
    
    If IsWindow(RequesterHandle)
      
      FrameGadget(#PB_Any, 5, 5, 385, 85, Language::Message("Encoding matrix count (per size)"))
      
      Text.i = TextGadget(#PB_Any, 10, 25, 375, 30, Language::Message("Count") + " : " + Str(Instance\Max))
      TrackBar.i = TrackBarGadget(#PB_Any, 10, 55, 375, 30, #MATRIX_COUNT_MIN, #MATRIX_COUNT_MAX)
      ButtonOK.i = ButtonGadget(#PB_Any, 195, 95, 95, 30, Language::Message("OK"))
      ButtonCancel.i = ButtonGadget(#PB_Any, 295, 95, 95, 30, Language::Message("Cancel"))
      
      SetGadgetState(TrackBar, Instance\Max)
      
      Repeat
        
        Select WaitWindowEvent()
            
          Case #PB_Event_CloseWindow
            Success.b = #False
            Exit_Condition = #True
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case TrackBar
                SetGadgetText(Text, Language::Message("Count") + " : " + Str(GetGadgetState(TrackBar)))
                
              Case ButtonOK
                SetMax(GetGadgetState(TrackBar))
                Success = #True
                Exit_Condition = #True
                
              Case ButtonCancel
                Success = #False
                Exit_Condition = #True
                
            EndSelect
            
        EndSelect
        
      Until Exit_Condition = #True
     
      CloseWindow(RequesterHandle)
      
    EndIf
    
    ProcedureReturn Success
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Matrix Finder Progression <<<<<
  
  Procedure MatrixFinder()
    
    MatrixFinderHandle = OpenWindow(#PB_Any, 0, 0, 400, 240, Language::Message("Matrix Finder Progression"), #PB_Window_SystemMenu | #PB_Window_ScreenCentered) 
    
    If IsWindow(MatrixFinderHandle)
      
      FrameGadget(#PB_Any, 5, 5, 390, 60, Language::Message("Matrix") + " 3x3")
      Secondary\ProgressBarMatrix33 = ProgressBarEx::Gadget(#PB_Any, 10, 30, 380, 30, 0) 
      ProgressBarEx::SetBackGroundColors(Secondary\ProgressBarMatrix33, RGB(255, 255, 000), RGB(000, 255, 000))
      
      FrameGadget(#PB_Any, 5, 70, 390, 60, Language::Message("Matrix") + " 4x4")
      Secondary\ProgressBarMatrix44 = ProgressBarEx::Gadget(#PB_Any, 10, 95, 380, 30, 0) 
      ProgressBarEx::SetBackGroundColors(Secondary\ProgressBarMatrix44, RGB(255, 255, 000), RGB(000, 255, 000))
      
      FrameGadget(#PB_Any, 5, 135, 390, 60, Language::Message("Matrix") + " 5x5")
      Secondary\ProgressBarMatrix55 = ProgressBarEx::Gadget(#PB_Any, 10, 160, 380, 30, 0) 
      ProgressBarEx::SetBackGroundColors(Secondary\ProgressBarMatrix55, RGB(255, 255, 000), RGB(000, 255, 000))
      
      ButtonCancel = ButtonGadget(#PB_Any, 300, 200, 95, 30, Language::Message("Cancel"))

      NewList Threads.i()
      
      AddElement(Threads())
      Threads() = CreateThread(@Matrix33Finder(), 0) ; 1 thread is enough
      
      AddElement(Threads())
      Threads() = CreateThread(@Matrix44Finder(), 0) ; 1 thread is enough
      
      ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ; The search of 5X5 matrix is very slow, So let's count how many core
      ; are available. Then launch as many threads as possible but leave one
      ; core for the rest of the OS. Indeed, start one thread if a single
      ; core is available. We will take the time needed to have the job done 
      ; in this case ! Parallelize the search but be civilized !
      
      Instance\MutexMatrix55 = CreateMutex()
      
      CPU_MAX = CountCPUs(#PB_System_ProcessCPUs) - 1
      
      If CPU_MAX = 0
        CPU_MAX = 1
      EndIf
      
      For CPU_ID = 1 To CPU_MAX
        AddElement(Threads())
        Threads() = CreateThread(@Matrix55Finder(), 0)
      Next

      Repeat
        
        If ProgressBarEx::GetState(Secondary\ProgressBarMatrix33) = 100 And ProgressBarEx::GetState(Secondary\ProgressBarMatrix44) = 100 And ProgressBarEx::GetState(Secondary\ProgressBarMatrix55) = 100
          Exit_Condition = #True
          Delay(1000)
        EndIf
        
        Select WaitWindowEvent()
            
          Case #PB_Event_CloseWindow
            Reset()
            SetAbandonState(#True)
            Exit_Condition = #True
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case ButtonCancel
                Reset()
                SetAbandonState(#True)
                Exit_Condition = #True
                
            EndSelect
            
        EndSelect
        
      Until Exit_Condition = #True
      
      ForEach Threads()
        
        If IsThread(Threads())
          WaitThread(Threads())
        EndIf
        
        Threads() = 0
        
      Next
      
      FreeList(Threads())
      
      If Instance\MutexMatrix55
        FreeMutex(Instance\MutexMatrix55)
        Instance\MutexMatrix55 = 0
      EndIf
      
      ProgressBarEx::Free(Secondary\ProgressBarMatrix33)
      ProgressBarEx::Free(Secondary\ProgressBarMatrix44)
      ProgressBarEx::Free(Secondary\ProgressBarMatrix55)
      
      CloseWindow(MatrixFinderHandle)

    EndIf
    
  EndProcedure
  
  Procedure Runner(MainWinID.i)
    
    If Instance\StartCounter < 3
      
      Instance\StartCounter + 1
      
    Else
      
      Instance\StartCounter = 0
      Initialize()
      
      HideWindow(MainWinID, 1)
      
      If Requester(MainWinID) = #True
        
        MatrixFinder()
        
        If Instance\AbandonState = #False
          Output = #True
        EndIf
        
      EndIf
      
      HideWindow(MainWinID, 0)
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Nom de la procdure <<<<<
  
  Procedure.s FormatMatrix33(*MatrixA.Matrix33::Matrix33, Name.s)
    
    Output00.s = Comments::Tabulation(4) + Matrix33::FormatLine1(*MatrixA, 0)
    Output00 = ReplaceString(Output00, "[", "SetMatrix33QLine1(" + Name)
    Output00 = ReplaceString(Output00, "]", ")") + #LineFeed
    
    Output01.s = Comments::Tabulation(4) + Matrix33::FormatLine2(*MatrixA, 0)
    Output01 = ReplaceString(Output01, "[", "SetMatrix33QLine2(" + Name)
    Output01 = ReplaceString(Output01, "]", ")") + #LineFeed
    
    Output02.s = Comments::Tabulation(4) + Matrix33::FormatLine3(*MatrixA, 0)
    Output02 = ReplaceString(Output02, "[", "SetMatrix33QLine3(" + Name)
    Output02 = ReplaceString(Output02, "]", ")") + #LineFeed
    
    Output03.s = Comments::Tabulation(4) + "MatrixSize = 3" + #TwinLineFeed
    
     ProcedureReturn ReplaceString(Output00 + Output01 + Output02, " : ", ", ") + Output03
  EndProcedure
  
  Procedure.s FormatMatrix44(*MatrixA.Matrix44::Matrix44, Name.s)
    
    Output00.s = Comments::Tabulation(4) + Matrix44::FormatLine1(*MatrixA, 0)
    Output00 = ReplaceString(Output00, "[", "SetMatrix44QLine1(" + Name)
    Output00 = ReplaceString(Output00, "]", ")") + #LineFeed
    
    Output01.s = Comments::Tabulation(4) + Matrix44::FormatLine2(*MatrixA, 0)
    Output01 = ReplaceString(Output01, "[", "SetMatrix44QLine2(" + Name)
    Output01 = ReplaceString(Output01, "]", ")") + #LineFeed
    
    Output02.s = Comments::Tabulation(4) + Matrix44::FormatLine3(*MatrixA, 0)
    Output02 = ReplaceString(Output02, "[", "SetMatrix44QLine3(" + Name)
    Output02 = ReplaceString(Output02, "]", ")") + #LineFeed
    
    Output03.s = Comments::Tabulation(4) + Matrix44::FormatLine4(*MatrixA, 0)
    Output03 = ReplaceString(Output03, "[", "SetMatrix44QLine4(" + Name)
    Output03 = ReplaceString(Output03, "]", ")") + #LineFeed
    
    Output04.s = Comments::Tabulation(4) +"MatrixSize = 4" + #TwinLineFeed
    
    ProcedureReturn ReplaceString(Output00 + Output01 + Output02 + Output03, " : ", ", ") + Output04  
  EndProcedure
  
  Procedure.s FormatMatrix55(*MatrixA.Matrix55::Matrix55, Name.s)
    
    Output00.s = Comments::Tabulation(4) + Matrix55::FormatLine1(*MatrixA, 0)
    Output00 = ReplaceString(Output00, "[", "SetMatrix55QLine1(" + Name)
    Output00 = ReplaceString(Output00, "]", ")") + #LineFeed
    
    Output01.s = Comments::Tabulation(4) + Matrix55::FormatLine2(*MatrixA, 0)
    Output01 = ReplaceString(Output01, "[", "SetMatrix55QLine2(" + Name)
    Output01 = ReplaceString(Output01, "]", ")") + #LineFeed
    
    Output02.s = Comments::Tabulation(4) + Matrix55::FormatLine3(*MatrixA, 0)
    Output02 = ReplaceString(Output02, "[", "SetMatrix55QLine3(" + Name)
    Output02 = ReplaceString(Output02, "]", ")") + #LineFeed
    
    Output03.s = Comments::Tabulation(4) + Matrix55::FormatLine4(*MatrixA, 0)
    Output03 = ReplaceString(Output03, "[", "SetMatrix55QLine4(" + Name)
    Output03 = ReplaceString(Output03, "]", ")") + #LineFeed
    
    Output04.s = Comments::Tabulation(4) + Matrix55::FormatLine5(*MatrixA, 0)
    Output04 = ReplaceString(Output04, "[", "SetMatrix55QLine5(" + Name)
    Output04 = ReplaceString(Output04, "]", ")") + #LineFeed
    
    Output05.s = Comments::Tabulation(4) +"MatrixSize = 5" + #TwinLineFeed
    
    ProcedureReturn ReplaceString(Output00 + Output01 + Output02 + Output03 + Output04, " : ", ", ") + Output05
  EndProcedure
  
  Procedure.s GenerateSource()
    
    Output.s = "DeclareModule MatrixEncoded" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Declare ME_WriteString(FileID.i, String.s)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteAsciiCharacter(FileID.i, Number.a)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteUnicodeCharacter(FileID.i, Number.u)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteByte(FileID.i, Number.b)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteWord(FileID.i, Number.w)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteCharacter(FileID.i, Number.c)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteLong(FileID.i, Number.l)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteInteger(FileID.i, Number.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteQuad(FileID.i, Number.q)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteFloat(FileID.i, Number.f)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare ME_WriteDouble(FileID.i, Number.d)" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Declare.s ME_ReadString(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.a ME_ReadAsciiCharacter(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.u ME_ReadUnicodeCharacter(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.b ME_ReadByte(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.w ME_ReadWord(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.c ME_ReadCharacter(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.i ME_ReadInteger(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.l ME_ReadLong(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.q ME_ReadQuad(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.f ME_ReadFloat(FileID.i)" + #LineFeed
    Output + Comments::Tabulation(1) + "Declare.d ME_ReadDouble(FileID.i)" + #TwinLineFeed
    
    Output + "EndDeclareModule" + #TwinLineFeed
    
    Output + "Module MatrixEncoded" + #TwinLineFeed
    
    Output + Comments::Section(Language::Message("Structures declaration"), 1)
    
    For IndexA = 3 To 5
      
      Output + Comments::Tabulation(1) + "Structure Vector" + Str(IndexA) + "Q" + #TwinLineFeed
      
      For IndexI = 1 To IndexA
        Output + Comments::Tabulation(2) + "e" + Str(IndexI) + ".q" + #LineFeed
      Next

      Output + #LineFeed
      Output + Comments::Tabulation(1) + "EndStructure" + #TwinLineFeed
      
    Next
    
    For IndexA = 3 To 5
      
      Output + Comments::Tabulation(1) + "Structure Matrix" + Str(IndexA) + Str(IndexA) + "Q" + #TwinLineFeed
      
      For IndexJ = 1 To IndexA
        For IndexI = 1 To IndexA
          Output + Comments::Tabulation(2) + "e" + Str(IndexI) + Str(IndexJ) + ".q" + #LineFeed
        Next
      Next
      Output + #LineFeed
      Output + Comments::Tabulation(1) + "EndStructure" + #TwinLineFeed
      
    Next
    
    Output + Comments::Section(Language::Message("The mutators"), 1)
    
    For IndexI = 1 To 3
      Output + Comments::Tabulation(1) + "Macro SetMatrix33QLine" + Str(IndexI) + "(MatrixA, P_e" + Str(IndexI) + "1, P_e" + Str(IndexI) + "2, P_e" + Str(IndexI) + "3)" + #TwinLineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "1 = P_e" + Str(IndexI) + "1" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "2 = P_e" + Str(IndexI) + "2" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "3 = P_e" + Str(IndexI) + "3" + #TwinLineFeed
      Output + Comments::Tabulation(1) + "EndMacro" + #TwinLineFeed
    Next
    
    For IndexI = 1 To 4
      Output + Comments::Tabulation(1) + "Macro SetMatrix44QLine" + Str(IndexI) + "(MatrixA, P_e" + Str(IndexI) + "1, P_e" + Str(IndexI) + "2, P_e" + Str(IndexI) + "3, P_e" + Str(IndexI) + "4)" + #TwinLineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "1 = P_e" + Str(IndexI) + "1" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "2 = P_e" + Str(IndexI) + "2" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "3 = P_e" + Str(IndexI) + "3" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "4 = P_e" + Str(IndexI) + "4" + #TwinLineFeed
      Output + Comments::Tabulation(1) + "EndMacro" + #TwinLineFeed
    Next
    
    For IndexI = 1 To 5
      Output + Comments::Tabulation(1) + "Macro SetMatrix55QLine" + Str(IndexI) + "(MatrixA, P_e" + Str(IndexI) + "1, P_e" + Str(IndexI) + "2, P_e" + Str(IndexI) + "3, P_e" + Str(IndexI) + "4, P_e" + Str(IndexI) + "5)" + #TwinLineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "1 = P_e" + Str(IndexI) + "1" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "2 = P_e" + Str(IndexI) + "2" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "3 = P_e" + Str(IndexI) + "3" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "4 = P_e" + Str(IndexI) + "4" + #LineFeed
      Output + Comments::Tabulation(2) + "MatrixA\e" + Str(IndexI) + "5 = P_e" + Str(IndexI) + "5" + #TwinLineFeed
      Output + Comments::Tabulation(1) + "EndMacro" + #TwinLineFeed
    Next
    
    Output + Comments::Section(Language::Message("The Product operator : R = A * B"), 1)
    
    Output + Comments::Tabulation(1) + "Macro ProductMatrix33QVector3Q(VectorR, MatrixA, VectorB)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "VectorR\e1 = MatrixA\e11 * VectorB\e1 + MatrixA\e12 * VectorB\e2 + MatrixA\e13 * VectorB\e3" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e2 = MatrixA\e21 * VectorB\e1 + MatrixA\e22 * VectorB\e2 + MatrixA\e23 * VectorB\e3" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e3 = MatrixA\e31 * VectorB\e1 + MatrixA\e32 * VectorB\e2 + MatrixA\e33 * VectorB\e3" + #TwinLineFeed
    Output + Comments::Tabulation(1) + "EndMacro" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Macro ProductMatrix44QVector4Q(VectorR, MatrixA, VectorB)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "VectorR\e1 = MatrixA\e11 * VectorB\e1 + MatrixA\e12 * VectorB\e2 + MatrixA\e13 * VectorB\e3 + MatrixA\e14 * VectorB\e4" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e2 = MatrixA\e21 * VectorB\e1 + MatrixA\e22 * VectorB\e2 + MatrixA\e23 * VectorB\e3 + MatrixA\e24 * VectorB\e4" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e3 = MatrixA\e31 * VectorB\e1 + MatrixA\e32 * VectorB\e2 + MatrixA\e33 * VectorB\e3 + MatrixA\e34 * VectorB\e4" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e4 = MatrixA\e41 * VectorB\e1 + MatrixA\e42 * VectorB\e2 + MatrixA\e43 * VectorB\e3 + MatrixA\e44 * VectorB\e4" + #TwinLineFeed
    Output + Comments::Tabulation(1) + "EndMacro" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Macro ProductMatrix55QVector5Q(VectorR, MatrixA, VectorB)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "VectorR\e1 = MatrixA\e11 * VectorB\e1 + MatrixA\e12 * VectorB\e2 + MatrixA\e13 * VectorB\e3 + MatrixA\e14 * VectorB\e4 + MatrixA\e15 * VectorB\e5" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e2 = MatrixA\e21 * VectorB\e1 + MatrixA\e22 * VectorB\e2 + MatrixA\e23 * VectorB\e3 + MatrixA\e24 * VectorB\e4 + MatrixA\e25 * VectorB\e5" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e3 = MatrixA\e31 * VectorB\e1 + MatrixA\e32 * VectorB\e2 + MatrixA\e33 * VectorB\e3 + MatrixA\e34 * VectorB\e4 + MatrixA\e35 * VectorB\e5" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e4 = MatrixA\e41 * VectorB\e1 + MatrixA\e42 * VectorB\e2 + MatrixA\e43 * VectorB\e3 + MatrixA\e44 * VectorB\e4 + MatrixA\e45 * VectorB\e5" + #LineFeed
    Output + Comments::Tabulation(2) + "VectorR\e5 = MatrixA\e51 * VectorB\e1 + MatrixA\e52 * VectorB\e2 + MatrixA\e53 * VectorB\e3 + MatrixA\e54 * VectorB\e4 + MatrixA\e55 * VectorB\e5" + #TwinLineFeed
    Output + Comments::Tabulation(1) + "EndMacro" + #TwinLineFeed
    
    Output + Comments::Section(Language::Message("Write in Encoded file"), 1)
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteString(FileID.l, String.s)" + #TwinLineFeed
    
    Output + Comments::Tabulation(2) + "Protected VectorCoded3.Vector3Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorDecoded3.Vector3Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorCoded4.Vector4Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorDecoded4.Vector4Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorCoded5.Vector5Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorDecoded5.Vector5Q" + #LineFeed
    
    Output + Comments::Tabulation(2) + "Protected Matrix33.Matrix33Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected Matrix44.Matrix44Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected Matrix55.Matrix55Q" + #LineFeed
    
    Output + Comments::Tabulation(2) + "Protected MatrixSize.b = 0" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected MatrixID.w = Random(" + Str(Instance\Max * 3 - 1) + ")" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "Select MatrixID" + #TwinLineFeed
    Counter = 0
  
    FirstElement(Instance\Matrix33())
    FirstElement(Instance\Matrix44())
    FirstElement(Instance\Matrix55())
    
    For Index = 0 To Instance\Max - 1
      
      Output + Comments::Tabulation(3) + "Case " + Str(Counter) + #LineFeed
      Output + FormatMatrix33(Instance\Matrix33(), "Matrix33, ")
      Counter + 1
      
      Output + Comments::Tabulation(3) + "Case " + Str(Counter) + #LineFeed
      Output + FormatMatrix44(Instance\Matrix44(), "Matrix44, ")
      Counter + 1
      
      Output + Comments::Tabulation(3) + "Case " + Str(Counter) + #LineFeed
      Output + FormatMatrix55(Instance\Matrix55(), "Matrix55, ")
      Counter + 1
      
      NextElement(Instance\Matrix33())
      NextElement(Instance\Matrix44())
      NextElement(Instance\Matrix55())
      
    Next
    
    Output + Comments::Tabulation(2) + "EndSelect" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "WriteWord(FileID, MatrixID)" + #LineFeed
    Output + Comments::Tabulation(2) + "MaxChar.l = Len(String)" + #LineFeed
    Output + Comments::Tabulation(2) + "WriteLong(FileID, MaxChar)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "Select MatrixSize" + #TwinLineFeed    
    Output + Comments::Tabulation(3) + "Case 3" + #TwinLineFeed  
    Output + Comments::Tabulation(4)  + "For Index = 0 To MaxChar - 1 Step 3" + #LineFeed
    
    For IndexI = 1 To 3
      Output + Comments::Tabulation(5) + "VectorDecoded3\e" + Str(IndexI) + " = Asc(Mid(String, Index + " + Str(IndexI) + ", 1))" + #LineFeed
    Next
    
    Output + Comments::Tabulation(5) + "ProductMatrix33QVector3Q(VectorCoded3, Matrix33, VectorDecoded3)" + #LineFeed
    Output + Comments::Tabulation(5) + "WriteData(FileID, VectorCoded3, SizeOf(Vector3Q))" + #LineFeed 
    Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed 

    Output + Comments::Tabulation(3) + "Case 4" + #TwinLineFeed  
    Output + Comments::Tabulation(4)  + "For Index = 0 To MaxChar - 1 Step 4" + #LineFeed
    
    For IndexI = 1 To 4
      Output + Comments::Tabulation(5) + "VectorDecoded4\e" + Str(IndexI) + " = Asc(Mid(String, Index + " + Str(IndexI) + ", 1))" + #LineFeed
    Next 
    
    Output + Comments::Tabulation(5) + "ProductMatrix44QVector4Q(VectorCoded4, Matrix44, VectorDecoded4)" + #LineFeed
    Output + Comments::Tabulation(5) + "WriteData(FileID, VectorCoded4, SizeOf(Vector4Q))" + #LineFeed 
    Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed 
    
    Output + Comments::Tabulation(3) + "Case 5" + #TwinLineFeed  
    Output + Comments::Tabulation(4)  + "For Index = 0 To MaxChar - 1 Step 5" + #LineFeed
    
    For IndexI = 1 To 5
      Output + Comments::Tabulation(5) + "VectorDecoded5\e" + Str(IndexI) + " = Asc(Mid(String, Index + " + Str(IndexI) + ", 1))" + #LineFeed
    Next 
    
    Output + Comments::Tabulation(5) + "ProductMatrix55QVector5Q(VectorCoded5, Matrix55, VectorDecoded5)" + #LineFeed
    Output + Comments::Tabulation(5) + "WriteData(FileID, VectorCoded5, SizeOf(Vector5Q))" + #LineFeed 
    Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed 

    Output + Comments::Tabulation(2) + "EndSelect" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteAsciiCharacter(FileID.i, Number.a)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, RSet(Str(Number), 6, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteUnicodeCharacter(FileID.i, Number.u)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, RSet(Str(Number), 10, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteByte(FileID.i, Number.b)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "If Number < 0" + #LineFeed
    Output + Comments::Tabulation(3) + "Sign.s = " + Chr(34) + "-" + Chr(34) + #LineFeed
    Output + Comments::Tabulation(3) + "Number = Number * -1" + #LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, Sign + RSet(Str(Number), 6, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteWord(FileID.i, Number.w)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "If Number < 0" + #LineFeed
    Output + Comments::Tabulation(3) + "Sign.s = " + Chr(34) + "-" + Chr(34) + #LineFeed
    Output + Comments::Tabulation(3) + "Number = Number * -1" + #LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, Sign + RSet(Str(Number), 10, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteCharacter(FileID.i, Number.c)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, RSet(Str(Number), 10, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteLong(FileID.i, Number.l)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "If Number < 0" + #LineFeed
    Output + Comments::Tabulation(3) + "Sign.s = " + Chr(34) + "-" + Chr(34) + #LineFeed
    Output + Comments::Tabulation(3) + "Number = Number * -1" + #LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, Sign + RSet(Str(Number), 22, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteInteger(FileID.i, Number.i)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "If Number < 0" + #LineFeed
    Output + Comments::Tabulation(3) + "Sign.s = " + Chr(34) + "-" + Chr(34) + #LineFeed
    Output + Comments::Tabulation(3) + "Number = Number * -1" + #LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, Sign + RSet(Str(Number), 42, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteQuad(FileID.i, Number.q)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "If Number < 0" + #LineFeed
    Output + Comments::Tabulation(3) + "Sign.s = " + Chr(34) + "-" + Chr(34) + #LineFeed
    Output + Comments::Tabulation(3) + "Number = Number * -1" + #LineFeed
    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, Sign + RSet(Str(Number), 42, " + Chr(34) + "0" + Chr(34) + "))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteFloat(FileID.i, Number.f)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, StrF(Number, 14))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure ME_WriteDouble(FileID.i, Number.d)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ME_WriteString(FileID, StrD(Number, 25))" + #TwinLinefeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Section(Language::Message("Read in Encoded file"), 1)
    
    Output + Comments::Tabulation(1) + "Procedure.s ME_ReadString(FileID.i)" + #TwinLinefeed
    
    Output + Comments::Tabulation(2) + "Protected VectorCoded3.Vector3Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorDecoded3.Vector3Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorCoded4.Vector4Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorDecoded4.Vector4Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorCoded5.Vector5Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected VectorDecoded5.Vector5Q" + #LineFeed
    
    Output + Comments::Tabulation(2) + "Protected Inverse33.Matrix33Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected Inverse44.Matrix44Q" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected Inverse55.Matrix55Q" + #LineFeed
    
    Output + Comments::Tabulation(2) + "Protected MatrixSize.b = 0" + #LineFeed
    Output + Comments::Tabulation(2) + "Protected MatrixID.w = ReadWord(FileID)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "Select MatrixID" + #TwinLineFeed
    Counter = 0
    
    FirstElement(Instance\Inverse33())
    FirstElement(Instance\Inverse44())
    FirstElement(Instance\Inverse55())
    
    For Index = 0 To Instance\Max - 1
      
      Output + Comments::Tabulation(3) + "Case " + Str(Counter) + #LineFeed
      Output + FormatMatrix33(Instance\Inverse33(), "Inverse33, ")
      Counter + 1
      
      Output + Comments::Tabulation(3) + "Case " + Str(Counter) + #LineFeed
      Output + FormatMatrix44(Instance\Inverse44(), "Inverse44, ")
      Counter + 1
      
      Output + Comments::Tabulation(3) + "Case " + Str(Counter) + #LineFeed
      Output + FormatMatrix55(Instance\Inverse55(), "Inverse55, ")
      Counter + 1
      
      NextElement(Instance\Inverse33())
      NextElement(Instance\Inverse44())
      NextElement(Instance\Inverse55())
      
    Next
    
    Output + Comments::Tabulation(2) + "EndSelect" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "MaxChar.l = ReadLong(FileID)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "Select MatrixSize" + #TwinLineFeed
    Output + Comments::Tabulation(3) + "Case 3" + #TwinLineFeed
    Output + Comments::Tabulation(4) + "For Index = 0 To MaxChar - 1 Step 3" + #LineFeed  
    Output + Comments::Tabulation(5) + "ReadData(FileID, VectorCoded3, SizeOf(Vector3Q))" + #LineFeed
    Output + Comments::Tabulation(5) + "ProductMatrix33QVector3Q(VectorDecoded3, Inverse33, VectorCoded3)" + #LineFeed
    Output + Comments::Tabulation(5) + "String.s = String + Chr(VectorDecoded3\e1) + Chr(VectorDecoded3\e2) + Chr(VectorDecoded3\e3)" + #LineFeed
    Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
    Output + Comments::Tabulation(3) + "Case 4" + #TwinLineFeed
    Output + Comments::Tabulation(4) + "For Index = 0 To MaxChar - 1 Step 4" + #LineFeed
    Output + Comments::Tabulation(5) + "ReadData(FileID, VectorCoded4, SizeOf(Vector4Q))" + #LineFeed
    Output + Comments::Tabulation(5) + "ProductMatrix44QVector4Q(VectorDecoded4, Inverse44, VectorCoded4)" + #LineFeed
    Output + Comments::Tabulation(5) + "String = String + Chr(VectorDecoded4\e1) + Chr(VectorDecoded4\e2) + Chr(VectorDecoded4\e3) + Chr(VectorDecoded4\e4)" + #LineFeed
    Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
    Output + Comments::Tabulation(3) + "Case 5" + #TwinLineFeed
    Output + Comments::Tabulation(4) + "For Index = 0 To MaxChar - 1 Step 5" + #LineFeed
    Output + Comments::Tabulation(5) + "ReadData(FileID, VectorCoded5, SizeOf(Vector5Q))" + #LineFeed
    Output + Comments::Tabulation(5) + "ProductMatrix55QVector5Q(VectorDecoded5, Inverse55, VectorCoded5)" + #LineFeed
    Output + Comments::Tabulation(5) + "String = String + Chr(VectorDecoded5\e1) + Chr(VectorDecoded5\e2) + Chr(VectorDecoded5\e3) + Chr(VectorDecoded5\e4) + Chr(VectorDecoded5\e5)" + #LineFeed
    Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "EndSelect" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ProcedureReturn String" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed

    Output + Comments::Tabulation(1) + "Procedure.a ME_ReadAsciiCharacter(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.u ME_ReadUnicodeCharacter(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.b ME_ReadByte(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.w ME_ReadWord(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.c ME_ReadCharacter(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.i ME_ReadInteger(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.l ME_ReadLong(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.q ME_ReadQuad(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn Val(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.f ME_ReadFloat(FileID.i)" + #TwinLinefeed
    Output + Comments::Tabulation(2) + "ProcedureReturn ValF(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
    
    Output + Comments::Tabulation(1) + "Procedure.d ME_ReadDouble(FileID.i)" + #TwinLineFeed
    Output + Comments::Tabulation(2) + "ProcedureReturn ValD(ME_ReadString(FileID))" + #LineFeed
    Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed

    Output + "EndModule" + #TwinLineFeed
    
    ProcedureReturn Output
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (139000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.62 (Linux - x64)
; Folding = --P-
; EnableThread
; EnableXP
; CompileSourceDirectory